
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>闲话Promise机制 / iVAN</title>

    <meta name="description" content="闲话Promise机制 Promise的诞生与Javascript中异步编程息息相关,js中异步编程主要指的是setTimout/setInterval.DOM事件机制.ajax,通过传入回调函数实现控制反转.异步编程为js带来强大灵活性的同时,也带来了嵌套回调的问题.详细来说主要有两点,第一嵌套太深代码可读性太差,第二并行逻辑必须串行执行. request = function(url, cb, eb) { var xhr = new XMLHttpRequest(); xhr.onreadystatechange">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">闲话Promise机制</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>　Promise的诞生与Javascript中异步编程息息相关，js中异步编程主要指的是setTimout/setInterval、DOM事件机制、ajax，通过传入回调函数实现控制反转。异步编程为js带来强大灵活性的同时，也带来了嵌套回调的问题。详细来说主要有两点，第一嵌套太深代码可读性太差，第二并行逻辑必须串行执行。</p>
<pre><code>request = function(url, cb, eb) {
    var xhr = new XMLHttpRequest();
    xhr.onreadystatechange = function() {
        if (xhr.readyState === 4) {
            if ((xhr.status &gt;=200 &amp;&amp; xhr.status &lt; 300) || xhr.status === 304) {
                cb(xhr.responseText);
            } else {
                eb(new Error({
                    message: xhr.status
                }));
            }
        }
    };
    xhr.open('get', url, true);
    xhr.send(null);
}</code></pre>
<p>这个例子中程序要依次处理data1、data2、data3，嵌套太多可读性太差</p>
<pre><code>//回调函数嵌套过深
request('data1.json', function(data1){
    console.log(data1);//处理data1
    request('data2.json', function(data2) {
        console.log(data2);//处理data2
        request('data3.json', function(data3) {
            console.log(data3);//处理data3

            alert('success');
        }, function(err) {
            console.error(err);
        });
    }, function(err) {
        console.error(err);
    });
}, function(err) {
    console.error(err);
});</code></pre>
<p>这个例子中程序需要请求data1、data2、data3数据，得到三个数据后才进行下一步处理。数据并不需要串行请求，但我们的代码却需要串行执行，增加了等待时间。</p>
<pre><code>//并行逻辑串行执行
request('data1', function(data1) {
    request('data2', function(data2) {
        request('data3', function(data3) {
            console.log(data1, data2, data3);//处理全部数据

            alert('success');
        }, function(err) {
            console.error(err);
        });
    }, function(err) {
        console.error(err);
    });
}, function(err) {
    console.error(err);
});</code></pre>
<p> </p>
<p><strong>Promise机制</strong></p>
<p>　　Promise机制便是上述问题的一种解决方案。与他相关的规范有<a href="http://wiki.commonjs.org/wiki/Promises/A" rel="external nofollow noreferrer">PromiseA</a>和<a href="https://promisesaplus.com/" rel="external nofollow noreferrer">PromiseA+</a>，PromiseA中对Promise进行了整体描述，PromiseA+对A进行了补充，在then函数的行为方面进行了更加详尽的阐述。</p>
<p>PromiseA+规范</p>
<p>A <em>promise</em> represents the eventual result of an asynchronous operation. </p>
<p>一个promise代表了一个异步操作的最终结果</p>
<p>The primary way of interacting with a promise is through its <code>then</code> method, which registers callbacks to receive either a promise’s eventual value or the reason why the promise cannot be fulfilled.跟promise交互的主要方式是通过他的then方法来注册回调函数去接收promise的最终结果值或者是promise不能完成的原因。</p>
<p>　　我们可以简单总结一下规范。每个promise都有三个状态：pending(默认)、fulfilled(完成)、rejected(失败)；默认状态可以转变为完成态或失败态，完成态与失败态之间无法相互转换，转变的过程是不可逆的，转变一旦完成promise对象就不能被修改。通过promise提供的then函数注册onFulfill(成功回调)、onReject(失败回调)、onProgres(进度回调)来与promise交互。Then函数返回一个promise对象（称为promise2，前者成为promise1），promise2受promise1状态的影响，具体请查看A+规范。</p>
<p>　　上两个规范中并没有说明promise的状态如何改变，大部分前端框架中使用Deferred来改变promise的状态（resolve()、reject（））。二者关系请看下图。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nMjAxNS80MTIwMjAvMjAxNTAzLzE2MDAxODQ3NTc0MzgxOS5wbmc=.jpg"></p>
<p>　　这里根据规范，我们实现一下promise</p>
<pre><code>Promise = function() {
    this.queue = [];
    this.value = null;
    this.status = 'pending';// pending fulfilled rejected
};

Promise.prototype.getQueue = function() {
    return this.queue;
};
Promise.prototype.getStatus = function() {
    return this.status;
};
Promise.prototype.setStatus = function(s, value) {
    if (s === 'fulfilled' || s === 'rejected') {
        this.status = s;
        this.value = value || null;
        this.queue = [];
        var freezeObject = Object.freeze || function(){};
        freezeObject(this);// promise的状态是不可逆的
    } else {
        throw new Error({
            message: "doesn't support status: " + s
        });
    }
};
Promise.prototype.isFulfilled = function() {
    return this.status === 'fulfilled';
};
Promise.prototype.isRejected = function() {
    return this.status === 'rejected';
}
Promise.prototype.isPending = function() {
    return this.status === 'pending';
}
Promise.prototype.then = function(onFulfilled, onRejected) {
    var handler = {
        'fulfilled': onFulfilled,
        'rejected': onRejected
    };
    handler.deferred = new Deferred();

    if (!this.isPending()) {//这里允许先改变promise状态后添加回调
        utils.procedure(this.status, handler, this.value);
    } else {
        this.queue.push(handler);//then may be called multiple times on the same promise;规范2.2.6
    }
    return handler.deferred.promise;//then must return a promise;规范2.2.7
};

var utils = (function(){
    var makeSignaler = function(deferred, type) {
        return function(result) {
            transition(deferred, type, result);
        }
    };

    var procedure = function(type, handler, result) {
        var func = handler[type];
        var def = handler.deferred;

        if (func) {
            try {
                var newResult = func(result);
                if (newResult &amp;&amp; typeof newResult.then === 'function') {//thenable
                    // 此种写法存在闭包容易造成内存泄露，我们通过高阶函数解决
                    // newResult.then(function(data) {
                    //     def.resolve(data);
                    // }, function(err) {
                    //     def.reject(err);
                    // });
                    //PromiseA+规范，x代表newResult，promise代表def.promise
                    //If x is a promise, adopt its state [3.4]:
                    //If x is pending, promise must remain pending until x is fulfilled or rejected.
                    //If/when x is fulfilled, fulfill promise with the same value.
                    //If/when x is rejected, reject promise with the same reason.
                    newResult.then(makeSignaler(def, 'fulfilled'), makeSignaler(def, 'rejected'));//此处的本质是利用了异步闭包
                } else {
                    transition(def, type, newResult);
                }
            } catch(err) {
                transition(def, 'rejected', err);
            }
        } else {
            transition(def, type, result);
        }
    };

    var transition = function(deferred, type, result) {
        if (type === 'fulfilled') {
            deferred.resolve(result);
        } else if (type === 'rejected') {
            deferred.reject(result);
        } else if (type !== 'pending') {
            throw new Error({
                'message': "doesn't support type: " + type
            });
        }
    };

    return {
        'procedure': procedure
    }
})();

Deferred = function() {
    this.promise = new Promise();
};

Deferred.prototype.resolve = function(result) {
    if (!this.promise.isPending()) {
        return;
    }

    var queue = this.promise.getQueue();
    for (var i = 0, len = queue.length; i &lt; len; i++) {
        utils.procedure('fulfilled', queue[i], result);
    }
    this.promise.setStatus('fulfilled', result);
};

Deferred.prototype.reject = function(err) {
    if (!this.promise.isPending()) {
        return;
    }

    var queue = this.promise.getQueue();
    for (var i = 0, len = queue.length; i &lt; len; i++) {
        utils.procedure('rejected', queue[i], err);
    }
    this.promise.setStatus('rejected', err);
}</code></pre>
<p>　　通过Promise机制我们的编程方式可以变成这样：</p>
<pre><code>request = function(url) {
    var def = new Deferred();

    var xhr = new XMLHttpRequest();
    xhr.onreadystatechange = function() {
        if (xhr.readyState === 4) {
            if ((xhr.status &gt;=200 &amp;&amp; xhr.status &lt; 300) || xhr.status === 304) {
                def.resolve(xhr.responseText)
            } else {//简化ajax，没有提供错误回调
                def.reject(new Error({
                    message: xhr.status
                }));
            }
        }
    };
    xhr.open('get', url, true);
    xhr.send(null);

    return def.promise;
}

request('data1.json').then(function(data1) {
    console.log(data1);//处理data1
    return request('data2.json');
}).then(function(data2) {
    console.log(data2);//处理data2
    return request('data3.json');
}, function(err) {
    console.error(err);
}).then(function(data3) {
    console.log(data3);
    alert('success');
}, function(err) {
    console.error(err);
});</code></pre>
<p>对于并行逻辑串行执行问题我们可以这样解决</p>
<pre><code>//所有异步操作都完成时，进入完成态，
//其中一项异步操作失败则进入失败态
all = function(requestArray) {
    // var some = Array.prototype.some;
    var def = new Deferred();
    var results = [];
    var total = 0;
    requestArray.some(function(r, idx) {
        //为数组中每一项注册回调函数
        r.then(function(data) {
            if (def.promise.isPending()) {
                total++;
                results[idx] = data;

                if (total === requestArray.length) {
                    def.resolve(results);
                }
            }
        },  function(err) {
            def.reject(err);
        });
        //如果不是等待状态则停止，比如requestArray[0]失败的话，剩下数组则不用继续注册
        return !def.promise.isPending();
    });

    return def.promise;
}

all(
    [request('data1.json'),
    request('data2.json'),
    request('data3.json')]
    ).then(
        function(results){
            console.log(results);// 处理data1,data2,data3
            alert('success');
    }, function(err) {
        console.error(err);
    });</code></pre>
<p>以下是几个测试案例</p>
<pre><code>//链式调用
var p1 = new Deferred();
p1.promise.then(function(result) {
    console.log('resolve: ', result);
    return result;
}, function(err) {
    console.log('reject: ', err);
    return err;
}).then(function(result) {
    console.log('resolve2: ', result);
    return result;
}, function(err) {
    console.log('reject2: ', err);
    return err;
}).then(function(result) {
    console.log('resolve3: ', result);
    return result;
}, function(err) {
    console.log('reject3: ', err);
    return err;
});
p1.resolve('success');
//p1.reject('failed');
p1.promise.then(function(result) {
    console.log('after resolve: ', result);
    return result;
}, function(err) {
    console.log('after reject: ', err);
    return err;
}).then(function(result) {
    console.log('after resolve2: ', result);
    return result;
}, function(err) {
    console.log('after reject2: ', err);
    return err;
}).then(function(result) {
    console.log('after resolve2: ', result);
    return result;
}, function(err) {
    console.log('after reject2: ', err);
    return err;
});

//串行异步
var p2 = new Deferred();
p2.promise.then(function(result) {
    var def = new Deferred();
    setTimeout(function(){
        console.log('resolve: ', result);
        def.resolve(result);
    })
    return def.promise;
}, function(err) {
    console.log('reject: ', err);
    return err;
}).then(function(result) {
    var def = new Deferred();
    setTimeout(function(){
        console.log('resolve2: ', result);
        def.reject(result);
    })
    return def.promise;
}, function(err) {
    console.log('reject2: ', err);
    return err;
}).then(function(result) {
    console.log('resolve3: ', result);
    return result;
}, function(err) {
    console.log('reject3: ', err);
    return err;
});
p2.resolve('success');

//并行异步
var p1 = function(){
    var def = new Deferred();
    setTimeout(function() {
        console.log('p1 success');
        def.resolve('p1 success');
    }, 20);

    return def.promise;
}
var p2 = function(){
    var def = new Deferred();
    setTimeout(function() {
        console.log('p2 failed');
        def.reject('p2 failed');
    }, 10);

    return def.promise;
}

var p3 = function(){
    var def = new Deferred();
    setTimeout(function() {
        console.log('p3 success');
        def.resolve('p3 success');
    }, 15);

    return def.promise;
}

all([p1(), p2(), p3()]).then(function(results) {
    console.log(results);
}, function(err) {
    console.error(err);
});</code></pre>
<p><strong>Promise优点</strong></p>
<p>对比使用Promise前后我们可以发现，传统异步编程通过嵌套回调函数的方式，等待异步操作结束后再执行下一步操作。过多的嵌套导致意大利面条式的代码，可读性差、耦合度高、扩展性低。通过Promise机制，扁平化的代码机构，大大提高了代码可读性；用同步编程的方式来编写异步代码，保存线性的代码逻辑，极大的降低了代码耦合性而提高了程序的可扩展性。</p>
<p> </p>
<p>Note：下图是我整理的dojo/Deferred模块的脉络图，使用dojo的道友可以看一下</p>
<p> </p>
<p>参考文章：</p>
<p><a href="http://www.cnblogs.com/rubylouvre/archive/2011/03/14/1982699.html" rel="external nofollow noreferrer">javascript 异步编程</a></p>
<p><a href="http://www.cnblogs.com/aaronjs/p/3356505.html" rel="external nofollow noreferrer">jQuery 2.0.3 源码分析 Deferred（最细的实现剖析，带图）</a></p>
<p><a href="http://www.cnblogs.com/hustskyking/p/javascript-asynchronous-programming.html" rel="external nofollow noreferrer">JavaScript异步编程原理</a></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-12 21:22:43</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/javascript/" title="javascript">javascript</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>闲话Promise机制的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/boR48vz.html" rel="bookmark">如何理解 JavaScript 中的 Promise 机制</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文讲的是如何理解 JavaScript 中的 Promise 机制, Promise 的世界 原生 Promises 是在 ES2015 对 JavaScript 做出最大的改变.它的出现消除了采用 callback 机制的很多潜在问题,并允许我们采用近乎同步的逻辑去写异步代码. 可以说 promises 和 generators ,代表了异步编程的新标准.不论你是否用它,你都得 必须 明白它们究竟是什么. Promise 提供了相当简单的 API ,但也增加了一点学习曲线.如果你以前从没见过			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pn4BoWb.html" rel="bookmark">&lbrack;React Native&rsqb;Promise机制</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				React Native中经常会看到Promise机制. Promise机制代表着在JavaScript程序中下一个伟大的范式.可以把一些复杂的代码轻松撸成一个串,和Android中的rxjava非常像. Promise代表一个任务结果,这个任务有可能完成,有可能没有完成.Promise模式唯一需要的一个接口是调用then方法,用来注册当Promise完成或者失败时调用的回调函数. 一般异步函数用到了Promise机制. 在异步操作之前通常异步操作是借助回调函数的. onScuccessCall			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlQZQnp.html" rel="bookmark">Promise机制的深入研究</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				上一篇文章只是简单的对promise原理有个简单的实现,这次增加了 all方法,同时调用多次异步请求 对resolve和reject方法进行了重构,增加了对多个异步调用的处理 对promse进行了改造,除掉了事件触发机制,增加了异步队列 详细代码如下: /** * Created with JetBrains WebStorm. * User: xuwenmin * Date: 14-4-26 * Time: 下午1:01 * To change this template use File |			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MrXDDjz.html" rel="bookmark">Javascript Promise机制的简单实现</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				promise/deferred 是一个很好的处理异步调用编码的规范,下面以nodejs代码为类,来实现一个promise/A 规范的简单实现 /** * Created with JetBrains WebStorm. * User: xuwenmin * Date: 14-4-1 * Time: 上午9:54 * To change this template use File | Settings | File Templates. */ var EventEmitter = requir			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/boLdPDM.html" rel="bookmark">nodejs中简单实现Javascript Promise机制的实例&lowbar;node&period;js</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				promise/deferred 是一个很好的处理异步调用编码的规范,下面以nodejs代码为类,来实现一个promise/A 规范的简单实现 复制代码 代码如下: /**  * Created with JetBrains WebStorm.  * User: xuwenmin  * Date: 14-4-1  * Time: 上午9:54  * To change this template use File | Settings | File Templates.  */ var Even			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/badWygz.html" rel="bookmark">一道关于Promise应用的面试题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				题目:红灯三秒亮一次,绿灯一秒亮一次,黄灯2秒亮一次:如何让三个灯不断交替重复亮灯?(用Promse实现) 三个亮灯函数已经存在: function red(){ console.log('red'); } function green(){ console.log('green'); } function yellow(){ console.log('yellow'); } 这道题首先考察Promise的应用,Promise的详细说明请看我的这篇文章:闲话Promise机制.首先我们需要一个函			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MNEYaNb.html" rel="bookmark">Promise&sol;A的误区以及实践</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				什么是Promise Promise是一种让异步代码书写起来更优雅的模式,能够让异步操作代码像同 步代码那样书写并且阅读,比如下面这个异步请求的例子: $.get(&quot;/js/script,js&quot;, function () { // callback to do }) 就可以改写为Promise模式: var promise = $.get(&quot;/js/script&quot;); 返回值promise即代表操作的最终结果.返回值promise也可以作为&quot;第 一类对象&			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z7235ap.html" rel="bookmark">Promise的前世今生和妙用技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				浏览器事件模型和回调机制 JavaScript作为单线程运行于浏览器之中,这是每本JavaScript教科书中都会被提到的.同时出于对UI线程操作的安全性考虑,JavaScript和UI线程也处于同一个线程中.因此对于长时间的耗时操作,将会阻塞UI的响应.为了更好的UI体验,应该尽量的避免JavaScript中执行较长耗时的操作(如大量for循环的对象diff等)或者是长时间I/O阻塞的任务.所以在浏览器中的大多数任务都是异步(无阻塞)执行的,例如:鼠标点击事件.窗口大小拖拉事件.定时器触发事件			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M1jVg8p.html" rel="bookmark">深入理解 Promise 五部曲：5&period; LEGO</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				[原文地址: https://segmentfault.com/a/1190000000611040] 在 Part4:扩展问题 中,我讨论了如何扩展和抽象Promise是多么的常见,以及这中间的一些问题.但是为什么promise对于开发者来说不是足够友好的呢?这就是它的设计用意吗? I've Got Friends In Low Places Promise被设计为低级别的构建块.一个promise就像一个乐高玩具.单个乐高只是一个有趣的玩具.但是如果把它们拼在一起,你会感受到更多的乐趣. 问			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/dzZ56pn.html" rel="bookmark" class="title">用ARDUNO自制RFID读写器、复旦M1卡初探</a>
					<div>
						1. 为什么要用Arduino 一提到,我们可能会想到ACR122.Proxmark3这些设备,还有Radiowar出售的专业级RFID设备,实际上我们完全可以自己使用arduino单片机和RC522 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/gpkw6dp.html" rel="bookmark" class="title">通过grub-install命令把grub安装到u盘</a>
					<div>
						通过grub-install命令把grub安装到u盘 ①准备一个u盘,容量不限,能有1MB都足够了. ②把u盘格式化(我把u盘格式化成FAT.fat32格式了,最后证明也是成功的).③开启linux系 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vMNm84b.html" rel="bookmark" class="title">c&plus;&plus;指针的应用及注意问题</a>
					<div>
						指针是c/c++学习一个比较让人头痛的问题,在程序设计过程中,指针也往往是产生隐含bug的原因.下面就来谈谈指针的应用以及需要注意的一些问题,里面也许就有你平时没有注意到的问题,希望能帮助各位读者理解 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qbaaWgb.html" rel="bookmark" class="title">快速精通掌握框架的使用</a>
					<div>
						初学者可以看看本人编写的框架标签的文章 FRAME(框架)是Web上经常会看到的页面结构.使用可视Web开发工具(比如Dreamweaver或者Frontpage),虽然可以在WYSIWYG环境中通过 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9Mx6KQz.html" rel="bookmark" class="title">利用脚本封装，方便实现网站悬浮广告</a>
					<div>
						封装|广告|脚本  下面是JS脚本(floatdiv.js) /*=================================================================== ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M911AvM.html" rel="bookmark" class="title">Apache&plus;Servlet&plus;Jsp环境设定（中）</a>
					<div>
						(二)Apache Server 1.双击apache_1_3_12_win32.exe文件进行安装,使用缺省配置进行安装,缺省安装目录为: C:\Program Files\Apache Group ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlROPVz.html" rel="bookmark" class="title">Android SurfaceView学习示例</a>
					<div>
						SurfaceView是View的子类,使用的方式与任何View所派生的类都是完全相同的,可以像其他View那样应用动画,并把它们放 到布局中. SurfaceView封装的Surface支持使用本章 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3N987z.html" rel="bookmark" class="title">ORACLE的性能测试经验总结</a>
					<div>
						前段时间,在阿里妈妈新机房压力测试过程中用到了LR测试ORACLE,跟DBA(杨军哥)一起在杭州网通新机房进行1000用户的压力模拟测试.整个压力测试耗时两天.以下是一些经验: 1)压力测试过程中发现 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJ7488b.html" rel="bookmark" class="title">谷歌Chrome浏览器无法访问微软网站怎么办</a>
					<div>
						  近期一些Windows用户使用谷歌Chrome浏览器访问微软网站的时候会出现无法连接问题,包括微软主站和附属的应用商店等.根据外媒报道,这可能是因为Chrome浏览器或者微软网站基础设施发生了改变 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1R4nap.html" rel="bookmark" class="title">在LinuxVPS下架设Minecraft服务器</a>
					<div>
						在LinuxVPS下架设Minecraft服务器 首先,下载最新JAVA:http://javadl.sun.com/webapps/download/AutoDL?BundleId=76851 网盘 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pd74x3M.html" rel="bookmark" class="title">js实现漂浮回顶部按钮实例</a>
					<div>
						  这篇文章主要介绍了js实现漂浮回顶部按钮的方法,实例分析了javascript实现返回顶部功能的样式与动态实现技巧,非常具有实用价值,需要的朋友可以参考下 ? 1 2 3 4 5 6 7 8 9  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm7aG5b.html" rel="bookmark" class="title">IIS安装Apache伪静态插件的具体操作图文</a>
					<div>
						Apache和IIS分别有自己的伪静态操作方法,那在Servers2003_IIS需要给PHP程序使用伪静态呢?安装rewrite插件包. 一.下载rewrite插件包,一般里面必须有httpd.in ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKkkPab.html" rel="bookmark" class="title">Linux中为什么硬链接不能指向目录</a>
					<div>
						  说法一: 如果使用 hard link 链接到目录时, 链接的数据需要连同被链接目录底下的所有数据都创建链接,举例来说,如果你要将 /etc 使用实体链接创建一个 /etc_hd 的目录时,那么在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDYmZvb.html" rel="bookmark" class="title">COLOURCO在线图片压缩神器和配色工具怎么样</a>
					<div>
						  今天和大家分享一个功能齐全.简单易用的在线配色工具网站Colour code,另外附上一个亲自实践后,感觉效果胜过TinyPNG的在线图片压缩网站,进来加书签吧 Colourco.de . 颜色变 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0WLmJb.html" rel="bookmark" class="title">爱思助手导入铃声失败、错误码2997怎么办</a>
					<div>
						  因为爱思助手这款软件的存在,iPhone用户可以使用它进行铃声的导入.设置以及DIY制作,让不少iPhone用户都下载了爱思助手.不过,一位网友在使用爱思助手的过程中,出现了导入铃声失败.错误码2 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlB9DLz.html" rel="bookmark" class="title">dwr返回时间报错-Error marshalling java&period;util&period;Date&colon; For input string&colon; &amp;amp&semi;amp&semi;quot&semi;2013-09-10&percnt;2013&percnt;3A09&amp;amp&semi;amp&semi;quot&semi;</a>
					<div>
						问题描述 Error marshalling java.util.Date: For input string: &quot;2013-09-10%2013%3A09&quot; 时间文本框: 通过d ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7YGrrM.html" rel="bookmark" class="title">win10系统下怎么安装pylucene</a>
					<div>
						问题描述 win10系统下怎么安装pylucene pylucene 不能用easy_install 直接安装,自己该怎么装? 解决方案 首先你的电脑上已经有windows系统(win7win8win ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/My3E94z.html" rel="bookmark" class="title">妹纸求助-vb纸牌游戏，如何洗牌？</a>
					<div>
						问题描述 vb纸牌游戏,如何洗牌? 在vb中,如何将扑克牌洗牌,就是将代码和图片结合起来,现在我能做出来一个取随机数的代码,也能显示图片,但是结合不上 解决方案 产生一个1~54的随机数,这个会不会? ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrXWqxz.html" rel="bookmark" class="title">exchange电子邮件重名</a>
					<div>
						问题描述 大家好!有新建存储组及公共存储,sales/salespublic,现在要新建一个电子邮件地址sales@domain.com,提示此组织中已存在此电子邮件地址,按proxyaddresse ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqRAkZp.html" rel="bookmark" class="title">Android ListView与适配器</a>
					<div>
						练习:实现如下图新闻列表, 并且添加点赞,且点击点赞.点攒数增加, 点击图片显示已点击了图片. 布局: &lt;?xml version=&quot;1.0&quot; encoding=&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z405LPz.html" rel="bookmark" class="title">网宿，这家和BAT同时创业的CDN之王的对与错</a>
					<div>
						最好的时候,网宿科技是A股&quot;第一高价股&quot;,141元的股价比国酒茅台还风光.3年后,尽管市场需求猛增,归属于上市公司股东的净利润却预计同比最高下降30%.从击败&quot;市场霸主& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqRGq3p.html" rel="bookmark" class="title">Python使用ntplib库同步校准当地时间的方法&lowbar;python</a>
					<div>
						NTP(Network Time Protocol)是由美国德拉瓦大学的David L. Mills教授于1985年提出,设计用来在Internet上使不同的机器能维持相同时间的一种通讯协定. NTP ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MydVW5b.html" rel="bookmark" class="title">滴滴出行与上海交通大学共建联合实验室，加速产学研合作进程</a>
					<div>
						9月26日下午,上海交通大学宣布与滴滴出行达成合作,共建联合实验室,共同加速产学研合作的进程,引领技术创新. 据雷锋网(公众号:雷锋网)了解,双方将依托上海交通大学约翰·霍普克罗夫特计算机科学中心,面 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bod0B3M.html" rel="bookmark" class="title">jquery  tab标签click事件触发失败</a>
					<div>
						问题描述 jquery tab标签click事件触发失败 有这串代码 只能触发第一个 tab 的onclick 没有这串代码 正常运行 这是为什么? 补充: //tab事件函数 tab.clickDo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNnVN7M.html" rel="bookmark" class="title">java-activiti流程变量的问题？？</a>
					<div>
						问题描述 activiti流程变量的问题?? java后台:if(DefinitionKey.equals(&quot;modifyApply&quot;)){ if(ra.equals(&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjwle6M.html" rel="bookmark" class="title">求助：关于文件的复制</a>
					<div>
						问题描述 高手请指教啊!怎么用字节流将硬盘上非C区的任意一个文件复制一份? 解决方案 解决方案二:http://www.java.happycodings.com/Core_Java/code12.h ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQjqmGM.html" rel="bookmark" class="title">WPF 窗体自定义标题栏 最大化为什么一半在屏幕外面</a>
					<div>
						问题描述 解决方案 解决方案二:我感觉,是你显示器的问题解决方案三:你是不是设置WindowStyle为None,又设置AllowsTransparency为True了?在这种情况下的window窗口 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/baBWwmM.html" rel="bookmark" class="title">在线急求解答！！关于 SliderShowExtender 链接数据库！</a>
					<div>
						问题描述 webservice.asmx.cs里的内容:[WebMethod]publicAjaxControlToolkit.Slide[]GetPhoto(){stringname=&quot;& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boL7PVM.html" rel="bookmark" class="title">前副总编、汽车事业部总经理何毅从搜狐离职加盟乐视</a>
					<div>
						摘要: 图为:搜狐汽车总经理何毅 8月2日上午消息,乐视造汽车的消息已经传出半月有余,消息人士透露,近日 搜狐 前副总编.汽车事业部总经理何毅从搜狐离职加盟乐视,未来或负责组建 图为:搜狐汽车总经理何 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7Qg8KM.html" rel="bookmark" class="title">详解Java设计模式之备忘录模式的使用&lowbar;java</a>
					<div>
						定义与结构     备忘录(Memento)模式又称标记(Token)模式.GOF给备忘录模式的定义为:在不破坏封装性的前提下,捕获一个对象的内部状态,并在该对象之外保存这个状态.这样以后就可将该对象 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.029 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
